System.Gadget.settingsUI = "Settings.html";
System.Gadget.onSettingsClosed = settingsClose;

document.onselectstart = function() {return false};

var locator = new ActiveXObject("WbemScripting.SWbemLocator");
var objWMIService = locator.ConnectServer(null, "root\\cimv2");
var fso = new ActiveXObject("Scripting.FileSystemObject");

var wql = "SELECT * FROM __InstanceModificationEvent Within 2 WHERE TargetInstance ISA 'Win32_NetworkAdapterConfiguration'"; //for check adapters

var NICs = new Array();

var Int_Nr;
var IPEnabled;

var currentgadgnum;
var locksselectionflag;

var timevarerr;
var timevaral;
var refreshErr;
var stoped;
var playsoundflag;
var soundplayed;
var soundfile;
var playsoundconnectionflag;
var soundconnectionfile;
var firstplaying;
var autoscaleDPIflag;

function init(){
 stoped = false;
 soundplayed = false; //Important
 pic.title = "Stop";
 getcurrentgadg(); //must me BEFORE loadsettingsfromfile()
 loadsettingsfromfile();
 loadSettings();
 main();
}

function getDPIsize(){
 try{
  var wshShell = new ActiveXObject("WScript.Shell");
  var getdefaultDPI = wshShell.RegRead("HKCU\\Control Panel\\Desktop\\LogPixels");
  size = parseInt((getdefaultDPI / 96) * 100) / 100;
  System.Gadget.Settings.write("SetSize", size);
 }
 catch (e){}
}

function getcurrentgadg(){
 currentgadgnum = System.Gadget.Settings.read("currentgadgetnum");
 if (currentgadgnum == ''){
  currentgadgnum = 0;
  System.Gadget.Settings.write("currentgadgetnum", currentgadgnum);
 }
}

function main(){
 connectstatusstr.style.visibility = "visible";
 alarm.style.visibility = "hidden";
 mysink.cancel();
 objWMIService.ExecNotificationQueryAsync(mysink, wql);
 CheckConnection();
}

function startstop(){
 if (!stoped){
  mysink.cancel();
  clearTimeout(timevarerr);
  clearTimeout(timevaral);
  stoped = true;
  pic.src = "images/Play.png";
  pic.title = "Start";
  connectstatusstr.style.visibility = "visible";
  alarm.style.visibility = "hidden";
 }
 else{
  stoped = false;
  pic.src = "images/Stop.png";
  pic.title = "Stop";
  main();
 }
}

function playalert(){
 System.Sound.playSound(soundfile);
 timevaral = setTimeout("playalert()",1000)
}

function connectionalarm(){
 if (stoped) return;
 if (playsoundflag) playalert();
 connectstatusstr.style.color = "#FF0000";
 connectstatusstr.innerHTML =  "NIC #" + NICs[Int_Nr] + " failure" + "&nbsp;&nbsp;&nbsp;&nbsp;";
 timevarerr = setTimeout("stopalert()",refreshErr);
}

function stopalert(){
 clearTimeout(timevaral);
 if (connectstatusstr.innerHTML.indexOf("OK") != -1) return;
 connectstatusstr.style.color = "#FF0000";
 connectstatusstr.innerHTML = "NIC #" + NICs[Int_Nr] + " failure" + "&nbsp;&nbsp;&nbsp;&nbsp;";
 connectstatusstr.style.visibility = "visible";
 alarm.style.visibility = "hidden";
}

function CheckConnection(){
 if (Int_Nr == "?" || NICs[Int_Nr] == undefined){
  connectstatusstr.style.color = "#FFCC00";
  connectstatusstr.innerHTML = "Select NIC first" + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  connectstatusstr.style.visibility = "visible";
  alarm.style.visibility = "hidden";
  return;
 }

 var sqlquery = "SELECT IPEnabled FROM Win32_NetworkAdapterConfiguration WHERE Index=" + NICs[Int_Nr];
 var NACdata = objWMIService.ExecQuery(sqlquery);
 try{
  IPEnabled = NACdata.ItemIndex(0).IPEnabled;
 }
 catch (e){IPEnabled = false}
 if (IPEnabled){
  connectstatusstr.style.color = "#7EE444";
  connectstatusstr.innerHTML = "NIC #" + NICs[Int_Nr] + " OK" + "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
  connectstatusstr.style.visibility = "visible";
  alarm.style.visibility = "hidden";

  if (firstplaying){
   if (playsoundconnectionflag){if (!soundplayed) System.Sound.playSound(soundconnectionfile)}
   soundplayed = true;
  }
  if (!firstplaying) firstplaying = true;
 }
 else{
  connectstatusstr.style.visibility = "hidden";
  alarm.style.visibility = "visible";
  soundplayed = false;
  connectionalarm();
 }
}

function settingsClose(){
 clearTimeout(timevarerr);
 clearTimeout(timevaral);
 getcurrentgadg();
 loadSettings();
 if (!stoped) main();
}

function loadSettings(){
 Int_Nr = System.Gadget.Settings.read("Int_Nr") + ""; //Warning. Convert to string
 if (Int_Nr == "") Int_Nr = "?";

 locksselectionflag = System.Gadget.Settings.read ("LOCKSSelection");
 if (locksselectionflag != "true"){
  locksselectionflag = false;
  System.Gadget.Settings.write ("LOCKSSelection", "false");
 }
 else{
  locksselectionflag = true;
  System.Gadget.Settings.write ("LOCKSSelection", "true");
 }

 size = System.Gadget.Settings.read("SetSize");
 if (size == '') {
  size = "1";
  System.Gadget.Settings.write("SetSize", size);
 }

 autoscaleDPIflag = System.Gadget.Settings.read ("DPIautoscale");
 if (autoscaleDPIflag != "false"){
  autoscaleDPIflag = true;
  System.Gadget.Settings.write ("DPIautoscale", "true");
 }
 else{
  autoscaleDPIflag = false;
  System.Gadget.Settings.write ("DPIautoscale", "false");
 }

 refreshErr = System.Gadget.Settings.read("refresherrtime");
 if (refreshErr == '') {
  refreshErr = "1000";
  System.Gadget.Settings.write("refresherrtime", refreshErr);
 }

 playsoundflag = System.Gadget.Settings.read ("PlaySound");
 if (playsoundflag != "false"){
  playsoundflag = true;
  System.Gadget.Settings.write ("PlaySound", "true");
 }
 else{
  playsoundflag = false;
  System.Gadget.Settings.write ("PlaySound", "false");
 }
 soundfile = System.Gadget.Settings.read("AlarmSound");
 if (soundfile == ""){
  soundfile = "media/failsound.wav";
  System.Gadget.Settings.write("AlarmSound", soundfile);
 }

 playsoundconnectionflag = System.Gadget.Settings.read ("PlayConnectionSound");
 if (playsoundconnectionflag!= "false"){
  playsoundconnectionflag = true;
  System.Gadget.Settings.write ("PlayConnectionSound", "true");
 }
 else{
  playsoundconnectionflag = false;
  System.Gadget.Settings.write ("PlayConnectionSound", "false");
 }
 soundconnectionfile = System.Gadget.Settings.read("ConnectionSound");
 if (soundconnectionfile == ""){
  soundconnectionfile = "media/fixedsound.wav";
  System.Gadget.Settings.write("ConnectionSound", soundconnectionfile);
 }
 firstplaying= System.Gadget.Settings.read ("PlayWhenStart");
 if (firstplaying!= "false"){
  firstplaying = true;
  System.Gadget.Settings.write ("PlayWhenStart", "true");
 }
 else{
  firstplaying = false;
  System.Gadget.Settings.write ("PlayWhenStart", "false");
 }

 if (autoscaleDPIflag) getDPIsize(); //Important!!!

 //top section
 connectstatusstr.style.top = parseInt(6 * size);
 alarm.style.top = parseInt(8 * size);
 stopstart.style.top = parseInt(8 * size);
 advertis.style.top = parseInt(23 * size);
 versionnumber.style.top = parseInt(23 * size);

 //left section
 alarm.style.left = parseInt(24 * size);
 advertis.style.left = parseInt(10 * size);

 //font-size section
 connectstatusstr.style.fontSize = parseInt(12 * size);
 advertis.style.fontSize = parseInt(10 * size);
 versionnumber.style.fontSize = parseInt(9 * size);
 
 //width section
 stopstart.style.width = parseInt(126 * size);
 versionnumber.style.width = parseInt(122 * size);
 
 //picture section
 warningpic.style.width = parseInt(80 * size);
 warningpic.style.height = parseInt(10 * size);
 pic.style.width = parseInt(16 * size);
 pic.style.height = parseInt(16 * size);
 
 //background section
 document.body.style.height = parseInt(41 * size);
 background.style.height = parseInt(41 * size);
 document.body.style.width = parseInt(130 * size);
 background.style.width = parseInt(130 * size);
}

function loadsettingsfromfile(){
 var inifilename = System.Environment.getEnvironmentVariable("APPDATA") + "\\" + System.Gadget.name + "_#" + currentgadgnum + "_Settings.ini";
 try{
  var inifile = fso.OpenTextFile(inifilename, 1); //1 read
   try{
    var tmp = inifile.ReadLine();
    tmp = inifile.ReadLine();
    tmp = inifile.ReadLine();
    if (tmp != ";meow") throw "old";

    locksselectionflag = inifile.ReadLine();
    System.Gadget.Settings.write("LOCKSSelection", locksselectionflag);
    size = inifile.ReadLine();
    System.Gadget.Settings.write("SetSize", size);
    refreshErr = inifile.ReadLine();
    System.Gadget.Settings.write("refresherrtime", refreshErr);
    playsoundflag = inifile.ReadLine();
    System.Gadget.Settings.write ("PlaySound", playsoundflag);
    soundfile = inifile.ReadLine();
    System.Gadget.Settings.write("AlarmSound", soundfile);
    playsoundconnectionflag = inifile.ReadLine();
    System.Gadget.Settings.write ("PlayConnectionSound", playsoundconnectionflag);
    soundconnectionfile = inifile.ReadLine();
    System.Gadget.Settings.write("ConnectionSound", soundconnectionfile);
    firstplaying = inifile.ReadLine();
    System.Gadget.Settings.write ("PlayWhenStart", firstplaying);
    autoscaleDPIflag = inifile.ReadLine();
    System.Gadget.Settings.write ("DPIautoscale", autoscaleDPIflag);

    if (locksselectionflag){
     Int_Nr = inifile.ReadLine();
     System.Gadget.Settings.write ("Int_Nr", Int_Nr);
     NICs[Int_Nr] = inifile.ReadLine();
    }

   }//end try 2

   finally {inifile.Close()}

 }//end try 1

 catch (e) {}
}

function runNetworkAndSharingCenter(){
 System.Shell.execute("control", "/name Microsoft.NetworkAndSharingCenter");
}